import ClearImageJNI.*; 

import java.io.*;  

public class Test {  
	
  public static void main(String args[])  
	{
	System.out.printf("Current directory: %s\n", TestUtil.getcwd());
		
 	try  { 
    TestCiApi.initCi();
 	  
	//   TestCiApi.testEnum();
	  int argc  = args.length;
	  while (true)
		  {
			try
			{
					// This might fail if no license
				for (int i = 1; i < argc; i++)
					if (!parseLine(TestCiApi.Image, args[i]))
						return;
				argc = 0; //  Input parsing is done

				String s = new String(new char[256]);
				//  Initialize COM
				for (; ;)
				{
					System.out.print("=======================================\n");
					System.out.print("Enter 'q'-quit, 'x'-'test.bmp', 'h' - help: ");
					// NOTE:   Do not use Cygwin Terminal shortcut "C:\cygwin\bin\mintty.exe -i /Cygwin-Terminal.ico -"
					//         STDIN works incorrectly
					BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
					s = in.readLine();
					if (!parseLine(TestCiApi.Image, s))
						break;
				}
				break;
			}
			catch (Exception ex)
			{
		 		TestCiApi.dump_error(ex);
			}	
		} // while
	}
	catch (Exception ex)
	{
 	TestCiApi.dump_error(ex);
	TestUtil.pause();
	return; // 1
	}	
	finally
	{
	try{TestCiApi.closeCi ();}catch(Exception ex){;}
	}
	TestUtil.pause();
	return;
	}
	
	private static String lastFilename = "";

	private static boolean parseLine(ICiImage Image, String s) throws  Exception // ezjcom.JComException
	{
		if (s == null)
			return true;
		s  = s.trim();
		if (!TestUtil.stricmp(s, "h") || !TestUtil.stricmp(s, "?"))
		{
				System.out.println("<[filename]- Image file to open. 'bmp' extension is added, if missing.");
				System.out.println("             Reopen last if no filename");
				// System.out.println("x          - open test.bmp");
				System.out.println("c          - close last image");
				System.out.println(">[filename]- save last image to file.  To '$testSave.bmp' if no filename");
				System.out.println("@[filename]- execute commands in filename");
				System.out.println("q          - quit");

				// cout << "b[+/-]     - enable/disable auto read barcodes.  Now: " << (TestCiApi.bAutoReadBarcodes ? "Enabled" : "Disabled") <<  endl;
				System.out.println("b[1pdq]    - read barcodes.  ");
				System.out.println("r          - repair image.");
				System.out.println("t          - tools (measurements)");
				System.out.println("w[N]       - color: 0 to BW (dflt), 1-to GS, 2-AdvBin(pres resol),");
				System.out.println("                    3-AdvBin, 4-AdvBin(to 200dpi)");
				System.out.println("i[t]       - server Information ");
				System.out.println("e          - force an error (Uninitialized image)");
		}
			else if (s.startsWith(">"))
			{
				if (s.length() == 1)
					TestIO._save(Image, "$testSave", "bmp", "", false);
				else
					TestIO._save(Image,  s.substring(1), "bmp", "", false);
				}
			else if (s.startsWith("@"))
			{
				String s1 = s.substring(1).trim();
				return parseCommandFile(Image, s1);
			}
			else if (s.startsWith("<") || !TestUtil.stricmp(s, "x"))
			{
					String fn = new String(new char[256]);
					fn = lastFilename;
					if (s.length() > 1 && s.startsWith("<"))
						fn = s.substring(1);
					else if (!TestUtil.stricmp(s, "x") || fn.length() == 0)
						fn = "test.bmp";
					if (!TestIO.OpenFromFile(Image, fn))
						{
						System.out.printf("Failed to read '%s'\n", fn);
						}
					else
					{
						lastFilename = fn; // Store successful name
						if (TestCiApi.bAutoReadBarcodes)
							TestCiApi.testReadBarcodes(Image, "");
					}
			}
			else if (!TestUtil.stricmp(s, "c"))
				Image.Close();
			else if (!TestUtil.stricmp(s, "q"))
					return false;
			else if (s.startsWith("#")) // Comment line
					;

			else if (!TestUtil.stricmp(s, "b+"))
				TestCiApi.bAutoReadBarcodes = true;
			else if (!TestUtil.stricmp(s, "b-"))
				TestCiApi.bAutoReadBarcodes = false;
			else if (s.startsWith("b"))
				TestCiApi.testReadBarcodes(Image, s.substring(1));
			else if (!TestUtil.stricmp(s, "r"))
				TestCiApi.testRepair(Image, s.substring(1));
			else if (!TestUtil.stricmp(s, "t"))
				TestCiApi.testTools(Image, s.substring(1));
			else if (s.startsWith("w") && s.length() <= 2)
				TestCiApi.testColor(Image, s.substring(1));
			else if (s.startsWith("i") && s.length() <= 2)
				TestCiApi.serverInformation(s.substring(1));
			else if (!TestUtil.stricmp(s, "e")) // Generate error
			{
				Image.Close();
				TestCiApi.testReadBarcodes(Image, "");
				Image.Invert();
			}
			else if (!TestUtil.stricmp(s, "z")) // TEMP tests
			{
			}

			else
			{
				if (s.length() > 0)
				{
					System.out.println("Unknown command: " + s);
	
				}
			}
			return true;
	}

	private static boolean parseCommandFile(ICiImage Image, String fileName) throws Exception // ezjcom.JComException
	{
		if (fileName == null || fileName.length() == 0)
			return true;
	    try {
	        //use buffering, reading one line at a time
	        //FileReader always assumes default encoding is OK!
	        BufferedReader input =  new BufferedReader(new FileReader(fileName));
	        try {
	          String line = null; //not declared within while loop
	          while (( line = input.readLine()) != null){
				if (!TestUtil.stricmp(line.trim(),  "exit"))
					break;
				if (!parseLine(Image, line))
					return false;
	          }
	          return true;
	        }
	         catch (IOException ex)
	         {
	 	 		TestCiApi.dump_error(ex);
	 			return true;
	         }
	        finally {
	          input.close();
	        }
	        
	  }
    catch (IOException ex)
    {
 		TestCiApi.dump_error(ex);
		return true;
    }
	}
}

