
import ClearImageJNI.*;

class TestCiApi {
    
 private static ICiServer Ci = null;
 protected static ICiImage Image  = null; 
 protected static boolean bAutoReadBarcodes = false;
 
 protected static void dump_error (Exception ex)
 {
	 System.out.println();
	 ex.printStackTrace();
 }
 protected static void serverInformation (String kind) throws Exception // ezjcom.JComException
 {
		System.out.println ("CiServer ver " + Ci.getVerMajor() + "." +  Ci.getVerMinor() + "." + Ci.getVerRelease());
		String info = Ci.getInfo(EInfoType.ciModulesList, 0); System.out.println (info); // COM
if (false) {
		String info1;
		info1 = Ci.getInfo(EInfoType.fromInt(200), 0); System.out.println (info1);	// LIB }
 		info1 = Ci.getInfo(EInfoType.fromInt(200), 1); System.out.println (info1);	// LIB }
		info1 = Ci.getInfo(EInfoType.fromInt(200), 2); System.out.println (info1);	// LIB }
		info1 = Ci.getInfo(EInfoType.fromInt(200), 25); System.out.println (info1);	// LIB }
  		}
}
 
 protected static void initCi () throws Exception // ezjcom.JComException
 	 {
	 	CiServer objCi;
	 	objCi = new CiServer();
	 	Ci = objCi.getICiServer();
		Ci.OpenServerUser("OracleOEM", "xxxxxxxx", "");	// not in COM in LIB
	 	serverInformation ("");
    	Image = Ci.CreateImage();
    } 
 
 protected static void closeCi () throws Exception // ezjcom.JComException
 	 {
		if (Image != null && Image.getIsValid() == EBoolean.ciTrue)
			Image.Close(); // memory leaks if not Closed
    }  
 
 protected static void testImage (String fileName, int pageNmb) throws Exception // ezjcom.JComException
 {
			try
			{
			// procFile (".\\C39_0.bmp", 1); // LIB
			procFile (fileName, pageNmb); // COM
			}
			finally
			{
			System.gc();
			}
 }
 
 private static void testCiImage (ICiImage Image) throws Exception // ezjcom.JComException
 {
			try
			{
			ICiImage img2 = Ci.CreateImage();
			img2.CreateBpp(300, 200, 1); 			TestIO._save(img2, "i10", "", "createBW", true);
			img2.CreateBpp(300, 200, 8); 			TestIO._save(img2, "i11", "", "createGS", true);
			img2.CreateBpp(300, 200, 24); 			TestIO._save(img2, "i12", "", "createRGB", true);
			img2.Create(400, 300); 					TestIO._save(img2, "i14", "", "create", true);
			img2.Invert();							TestIO._save(img2, "i15", "", "invert", true);
			// BAD img2.Crop(20, 20,  20, 20);				TestIO._save(img2, "i", "", "crop20", true);
			img2.Crop(20, 20,  img2.getWidth() - 20, img2.getHeight() - 20);		TestIO._save(img2, "i16", "", "crop20", true);
			ICiRect r = Ci.CreateRect(img2.getWidth() /4, img2.getHeight()/3, img2.getWidth()*3/4, img2.getHeight()*2/3);
			ICiImage zone = img2.CreateZoneRect(r);	TestIO._save(zone, "i20", "", "zoneExtracted", true);
			zone.Clear();							TestIO._save(img2, "i21", "", "zoneCleared", true);
			zone = img2.CreateZone(img2.getWidth()/3, img2.getHeight()/4, img2.getWidth()*2/3, img2.getHeight()*3/4);
			zone.Invert();							TestIO._save(img2, "i22", "", "zoneInverted", true);
			img2.ToBitonal();						TestIO._save(img2, "i23", "", "toBitonal", true);
			img2.ToGrayscale();						TestIO._save(img2, "i24", "", "toGrayscale", true);			
			ICiImage img3 =	Image.Duplicate();		 TestIO._save(img3, "i30", "", "duplicated", true);
			img2.Copy(img3);						 TestIO._save(img2, "i31", "", "copied", true);
			img2.Flip();							 TestIO._save(img2, "i32", "", "flip", true);
			img2.Copy(img3);img2.FlipHorz();		 TestIO._save(img2, "i33", "", "flipHorz", true);
			img2.Copy(img3);img2.FlipVert();		 TestIO._save(img2, "i34", "", "flipVert", true);
			img2.Copy(img3);img2.RotateLeft();		 TestIO._save(img2, "i35", "", "rotLeft", true);
			img2.Copy(img3);img2.RotateRight();		 TestIO._save(img2, "i36", "", "rotRight", true);
		    System.out.println ("Image w: " + img2.getWidth() + " h: " + img2.getHeight() + "  bpp: " + img2.getBitsPerPixel() +
		    	                        "  hdpi: " +  img2.getHorzDpi() + "  vdpi: " + img2.getVertDpi());
			img2.Create(800, 1200); 		
			img2.setHorzDpi(400);
			img2.setVertDpi(320);		    
		    System.out.println ("Image w: " + img2.getWidth() + " h: " + img2.getHeight() + "  bpp: " + img2.getBitsPerPixel() +
		    	                        "  hdpi: " +  img2.getHorzDpi() + "  vdpi: " + img2.getVertDpi());
			}
			finally
			{
			System.gc();
			}
 }
    
  private static void procFile (String fileName, int pageNmb) throws Exception // ezjcom.JComException
    {

    	ICiImage Image= null;
    	try
	    	{
    		Image = Ci.CreateImage();
    		Image.Open(fileName, pageNmb);
	    //	System.out.println ("Image w: " + Image.getWidth() + " h: " + Image.getHeight() + "  bpp: " + Image.getBitsPerPixel() +
	    //	                        "  hdpi: " +  Image.getHorzDpi() + "  vdpi: " + Image.getVertDpi());
    		testCiImage(Image);
	    	testCiBarcodePro(Image);
			// testCiTools(Image);
	    	/*
			image.Invert();
			image.SaveToFileBMP(".\\$testOut.bmp");
			*/
	    	}
    	finally
	    	{
	    	if ((Image != null) && (Image.getIsValid() == EBoolean.ciTrue))
	    		Image.Close();
	    	}
    }
 
 
	private static void printBarcode (int index, ICiBarcode bc) throws Exception // ezjcom.JComException
	{
    System.out.println ("-------------------------------");
    System.out.println ("#" + index + "  type: " +   bc.getType() +
       "  length: " + bc.getLength() +
    	 "  rot: " + bc.getRotation() +
       "  rect: " + bc.getRect().getLeft() + ":" +   bc.getRect().getTop() + "-" + bc.getRect().getRight() + ":" +   bc.getRect().getBottom() + 
       "  mod(pix): " + bc.getModuleSize());
       // Print results as text
    System.out.println ("Text: \n" +  bc.getText());
    	// Print results as HEX data
    // byte data[] = bc.getData().getByteArray();
    byte data[] = bc.getData();
    System.out.println ("Data:");
   	for (int i = 0; i < data.length; i++)
			{	if (((i % 16) == 0) && (i != 0)) 	System.out.println(""); // break after 16 bytes 
				System.out.format("%1$2H ",(int)  data[i]);
				}
		System.out.println("");
	}

	  static void testEnum ()
	   {
		  	// Regular enum
		  System.out.println("  ====== EBarcodeType ==== NON-MASKED Enum");	
		  EBarcodeType ebt;
		  ebt = EBarcodeType.cibCode128;
		  System.out.println("ebt[cibCode128] = " + ebt + " val = " + ebt.toInt());		  
		  
		  /* implemented only for Masked enum
		  ebt = EBarcodeType.fromList(EBarcodeType.cibCode128, EBarcodeType.cibCode39);
		  System.out.println("ebt[cibCode128|cibCode39] = " + ebt + " val = " + ebt.toInt());	
		  */	  
		  
		  ebt = EBarcodeType.fromInt(78);
		  System.out.println("ebt[78] = " + ebt + " val = " + ebt.toInt());

		  System.out.println("  ====== FBarcodeDirections ==== MASKED Enum");		  
		  FBarcodeDirections fbd;
		  fbd = FBarcodeDirections.cibHorz;
		  System.out.println("fbd[cibHorz] = " + fbd + " val = " + fbd.toInt());		
		  
		  fbd = FBarcodeDirections.fromInt(4);
		  System.out.println("fbd[4]       = " + fbd + " val = " + fbd.toInt());		
		  
		  fbd = FBarcodeDirections.fromInt(10);
		  System.out.println("fbd[10]      = " + fbd + " val = " + fbd.toInt());	
		  
		  /*  Not implemented
		  fbd = FBarcodeDirections.fromList(FBarcodeDirections.cibHorz, FBarcodeDirections.cibVert);
		  System.out.println("fbd[cibHorz|cibVert]  = " + fbd + " val = " + fbd.toInt());	
		  */
		  
		  fbd = new FBarcodeDirections(FBarcodeDirections.cibDiag, FBarcodeDirections.cibVert);
		  System.out.println("fbd[CONSTR cibDiag|cibVert]  = " + fbd + " val = " + fbd.toInt());	
		  
		  /*
		  
		FBarcodeType[] arr = FBarcodeType.toArray(5325);
		for (FBarcodeType f: arr)
		   System.out.println("FBarcodeType: " + f + " int: " + f.toInt());	
		
		FBarcodeType f2 = FBarcodeType.cibf4State;
	 		   System.out.println("FBarcodeType f2: " + f2 + " int: " + f2.toInt());	
	 		   
	   	EBarcodeType en = EBarcodeType.cibMatrix2of5;
	   	EBarcodeType en2 = en; 
	    System.out.println("EBarcodeType: " + EBarcodeType.cibCode39 + " en: " + en + " en2: " + en2);	
	   	
	   	int nval = 6;
	   	int i =  en.toInt();
	   	EBarcodeType en3 = EBarcodeType.fromInt(nval);
	    System.out.println("EBarcodeType INT (" + nval + "): " +   " ToInt:" + i + "  fromInt" + en3 + "  fromInt (invalid): " + EBarcodeType.fromInt(50));	
	    
	   i =  en.ordinal();
	   EBarcodeType en4 = EBarcodeType.values()[nval];
	   // EBarcodeType en5 = EBarcodeType.values()[50]; // ArrayOutOfBounds error
	   System.out.println("EBarcodeType ORDINAL (" + nval + "): " +  " ToInt:" + i + "  fromInt" + en4);	
	 
	    
	    boolean bneq = (en3 == en2);
	   	boolean beq = (en == en2);
	    System.out.println("EBarcodeType BOOL: " + " eq: " + beq + " neq: " + bneq);	
	 */  	   	
	  }

	  protected static void testReadBarcodes(ICiImage Image, String p)
	  {
	  		try
	  		{
	  			//  test Barcode recognition
	  			if (p.length() == 0 || p.indexOf('1') >= 0)
	  			  testCiBarcodePro(Image);
	  			if (p.length() == 0 || p.indexOf('p') >= 0)
	  				testCiPdf417(Image);
	  			if (p.length() == 0 || p.indexOf('d') >= 0)
	  				testCiDataMatrix(Image);
	  			if (p.length() == 0 || p.indexOf('q') >= 0)
	  				testCiQR(Image);
	  		}
	  	catch (Exception ex)
	  	{
	  		dump_error(ex);
	  	}
	  }


	  //===============================================================
	  protected static void testCiDataMatrix(ICiImage Image)
	  {
	  		try
	  		{
	  	int i = 0;
	  	ICiDataMatrix Bcr = Ci.CreateDataMatrix();
	  	Bcr.setImage(Image);
	  	// Bcr.setAlgorithm(EBarcodeAlgorithm.cibBestRecognition); // This is default
	  	// Bcr.setDirections( new FBarcodeDirections(FBarcodeDirections.cibHorz, FBarcodeDirections.cibVert, FBarcodeDirections.cibVert)); // This is default
  	
	  	// ICiBarcode Bc = Bcr.FirstBarcode();  // Use of FirstBarcode / Next Barcode
	  	// while (Bc != null) {i++;
	  	//	printBarcode(i, Bc);	Bc = Bcr.NextBarcode();	}
	  	int n = Bcr.Find(0);
	  	for (i = 1; i <= n; i++)	{
	  		ICiBarcode Bc = Bcr.getBarcodes().getItem(i); // getItem is 1-based
	  		printBarcode(i, Bc);}
	  	}
	  	catch (Exception ex)
	  	{
	  		dump_error(ex);
	  	}
	  }

	  //===============================================================
	  protected static void testCiQR(ICiImage Image)
	  {
	  		try
	  		{
	  	int i = 0;
	  	ICiQR Bcr = Ci.CreateQR();
	  	Bcr.setImage(Image);
	  	// Bcr.setAlgorithm(EBarcodeAlgorithm.cibBestRecognition); // This is default
	  	// Bcr.setDirections( new FBarcodeDirections(FBarcodeDirections.cibHorz, FBarcodeDirections.cibVert, FBarcodeDirections.cibVert)); // This is default
  	
	  	// ICiBarcode Bc = Bcr.FirstBarcode();  // Use of FirstBarcode / Next Barcode
	  	// while (Bc != null) {i++;
	  	//	printBarcode(i, Bc);	Bc = Bcr.NextBarcode();	}
	  	int n = Bcr.Find(0);
	  	for (i = 1; i <= n; i++)	{
	  		ICiBarcode Bc = Bcr.getBarcodes().getItem(i); // getItem is 1-based
	  		printBarcode(i, Bc);}
	  	}
	  	catch (Exception ex)
	  	{
	  		dump_error(ex);
	  	}
	  }

	  //===============================================================
	  protected static void testCiBarcodePro(ICiImage Image)
	  {
	  		try
	  		{
	  	int i = 0;
	  	ICiBarcodePro Bcr = Ci.CreateBarcodePro();
	  	Bcr.setImage(Image);
	  	
	  	/// Bcr.setAlgorithm(EBarcodeAlgorithm.cibBestRecognition); // This is default
	  	// Bcr.setDirections( new FBarcodeDirections(FBarcodeDirections.cibHorz, FBarcodeDirections.cibVert, FBarcodeDirections.cibVert)); // This is default
	    Bcr.setAutoDetect1D(EBoolean.ciFalse);     //    bcr.setAutoDetect1D(EBoolean.ciTrue);
	    // Bcr.setType (FBarcodeType.cibfCode39);  //    single type
	    Bcr.setType (new FBarcodeType(FBarcodeType.cibfCode39, FBarcodeType.cibfCode128));	  // Multiple types
	  	
  	
	  	// ICiBarcode Bc = Bcr.FirstBarcode();  // Use of FirstBarcode / Next Barcode
	  	// while (Bc != null) {i++;
	  	//	printBarcode(i, Bc);	Bc = Bcr.NextBarcode();	}

	  	int n = Bcr.Find(0);
	  	for (i = 1; i <= n; i++)	{
	  		ICiBarcode Bc = Bcr.getBarcodes().getItem(i); // getItem is 1-based
	  		printBarcode(i, Bc);}
	  	}
	  	catch (Exception ex)
	  	{
	  		dump_error(ex);
	  	}
	  }

	  protected static void testCiPdf417(ICiImage Image)
	  {
	  	try
	  	{
	  	int i = 0;
	  	ICiPdf417 Bcr = Ci.CreatePdf417();
	  	Bcr.setImage(Image);
	  	/// Bcr.setAlgorithm(EBarcodeAlgorithm.cibBestRecognition); // This is default
	  	// Bcr.setDirections( new FBarcodeDirections(FBarcodeDirections.cibHorz, FBarcodeDirections.cibVert, FBarcodeDirections.cibVert)); // This is default

	  	// ICiBarcode Bc = Bcr.FirstBarcode();  // Use of FirstBarcode / Next Barcode
	  	// while (Bc != null) {i++;
	  	//	printBarcode(i, Bc);	Bc = Bcr.NextBarcode();	}

	  	int n = Bcr.Find(0);
	  	for (i = 1; i <= n; i++)	{
	  		ICiBarcode Bc = Bcr.getBarcodes().getItem(i); // getItem is 1-based
	  		printBarcode(i, Bc);}
	  	}
	  	catch (Exception ex)
	  	{
	  		dump_error(ex);
	  	}
	  }
	  //===============================================================
	  protected static void testRepair(ICiImage Image, String kind)
	  {	  	try
	  	{
	  	if (Image.getIsValid() == EBoolean.ciTrue)
	  		TestIO._save(Image, "r10", "bmp", "beforeRepair", false);
	  	ICiRepair repair = Ci.CreateRepair();
	  	repair.setImage(Image);
	  	repair.BorderExtract(EBorderExtractFlags.ciBexBorderDeskewCrop, EBorderExtractAlgorithm.ciBeaCleaner);
	  	System.out.println("BorderExtract  ");
	  	repair.setPLineCurvature(ELineCurvature.ciCurvLow);
	  	repair.setPMinLineLength(100);
	  	repair.setPMaxLineGap(5);
	  	repair.DeleteLines(ELineDirection.ciLineVertAndHorz, EBoolean.ciFalse);
	  	System.out.println("DeleteLines  ");
	  	repair.AutoDeskew();
	  	System.out.println("AutoDeskew  ");
	  	repair.AutoRotate();
	  	System.out.println("AutoRotate  ");
	  	repair.CleanNoiseExt(new ECleanNoiseFlags(ECleanNoiseFlags.ciCnxBlackNoise, ECleanNoiseFlags. ciCnxWhiteNoise), 3, 3, 10, 0);
	  	System.out.println("CleanNoiseExt  ");
	  	repair.RemovePunchHoles();
	  	System.out.println("RemovePunchHoles  ");
	  	repair.AutoCrop(10,10,10,10);
	  	System.out.println("AutoCrop  ");
	  	TestIO._save(Image, "r50", "bmp", "afterRepair", false);
	  	}
	  	catch (Exception ex)
	  	{
	  		dump_error(ex);
	  	}
	  }

	  //===============================================================
	  protected static void testColor(ICiImage Image, String type)
	  {
	  	try
	  	{
	  	if (Image.getIsValid() == EBoolean.ciTrue)
	  		TestIO._save(Image, "c10", "bmp", "beforeColor", false);
	  	ICiRepair repair = Ci.CreateRepair();
	  	repair.setImage(Image);
	  	if (type.length() == 0) type = "0";
	  	switch (type.charAt(0))
	  	{
	  	case '0':
	  	  Image.ToBitonal();
	  	  System.out.println("ToBitonal  ");
	  		break;
	  	case '1':
	  	  Image.ToGrayscale();
	  	  System.out.println("ToGrayscale  ");
	  		break;
	  	case '2':
	  	  repair.AdvancedBinarize(-1, 0, 0); // Preserve resolution
	  	  System.out.println("AdvancedBinarize (preserve resolution)  ");
	  		break;
	  	case '3':
	  	  repair.AdvancedBinarize(0, 0, 0); // Preserve resolution
	  	  System.out.println("AdvancedBinarize  ");
	  		break;
	  	case '4':
	  	  repair.AdvancedBinarize(200, 0, 0); // Preserve resolution
	  	  System.out.println("AdvancedBinarize to 200dpi ");
	  		break;
	  	default:
	  		System.out.print("Unknow convertion type :");
	  		System.out.println(type);

	  	}
	  	TestIO._save(Image, "c50", "bmp", "afterColor", false);
	  	}
	  	catch (Exception ex)
	  	{
	  		dump_error(ex);
	  	}
	  }

	  protected static void testTools(ICiImage Image, String kind)
	  {
	  	try
	  	{
	  	ICiTools tools = Ci.CreateTools();
	  	tools.setImage(Image);
	  	System.out.println("w: " + Image.getWidth() + "   h: " + Image.getHeight() + "   bpp: "+ Image.getBitsPerPixel() +
	  	 "   hdpi: " + Image.getHorzDpi() + "   vdpi: " + Image.getVertDpi());
	  	double skew = tools.MeasureSkew();
	    double conf = tools.getRConfidence();
	  	System.out.println("skew: " + skew + "   conf: " + conf);
	    EPageRotation eRot = tools.MeasureRotation();
	    conf = tools.getRConfidence();
	  	System.out.println ("rot: "  + eRot + "   conf: " + conf);
	  	int pixels = tools.CountPixels();
	  	System.out.println("pixels: " + pixels);
	  	ICiRect rect = tools.MeasureMargins();
	  	System.out.println("margins l: " + rect.getLeft() + "   t: " + rect.getTop() + 
	  	   "   r: " + (Image.getWidth() - rect.getRight() - 1) + "   b: " + (Image.getHeight() - rect.getBottom() - 1));
	  	}
	  	catch (Exception ex)
	  	{
	  		dump_error(ex);
	  	}
	  }

	
}